/******************************/
/* LN^f[^ϊ */
/******************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	16
#define	MAXHEIGHT	(256*8)
#define	MAXCHARA	(256+6)

void	fput4b(int,FILE *);
void	outheader(int,int,FILE *);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[8][8][MAXCHARA];
	int		pixel_all[MAXWIDTH][MAXHEIGHT];

	int		width_all, height_all;
	int		width, height, w_mul, h_mul;
	int		size, patnum, offset;
	int		x, y, z, col;
	int		xx, yy;
	int		c, i, sft, a0, a1;
	int		bmpflag, plnum;

	int		fixpat[6][8][8] = {
		{{ 0, 0, 1, 1, 1, 0, 0, 0 },	// 
		 { 0, 0, 1, 1, 1, 0, 0, 0 },
		 { 0, 0, 1, 1, 1, 0, 0, 0 },
		 { 1, 1, 1, 1, 1, 1, 1, 0 },
		 { 0, 1, 1, 1, 1, 1, 0, 0 },
		 { 0, 0, 1, 1, 1, 0, 0, 0 },
		 { 0, 0, 0, 1, 0, 0, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 }},
		{{ 0, 0, 0, 1, 0, 0, 0, 0 },	// 
		 { 0, 0, 1, 1, 1, 0, 0, 0 },
		 { 0, 1, 1, 1, 1, 1, 0, 0 },
		 { 1, 1, 1, 1, 1, 1, 1, 0 },
		 { 0, 0, 1, 1, 1, 0, 0, 0 },
		 { 0, 0, 1, 1, 1, 0, 0, 0 },
		 { 0, 0, 1, 1, 1, 0, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 }},
		{{ 0, 0, 0, 1, 0, 0, 0, 0 },	// 
		 { 0, 0, 0, 1, 1, 0, 0, 0 },
		 { 1, 1, 1, 1, 1, 1, 0, 0 },
		 { 1, 1, 1, 1, 1, 1, 1, 0 },
		 { 1, 1, 1, 1, 1, 1, 0, 0 },
		 { 0, 0, 0, 1, 1, 0, 0, 0 },
		 { 0, 0, 0, 1, 0, 0, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 }},
		{{ 0, 0, 0, 1, 0, 0, 0, 0 },	// 
		 { 0, 0, 1, 1, 0, 0, 0, 0 },
		 { 0, 1, 1, 1, 1, 1, 1, 0 },
		 { 1, 1, 1, 1, 1, 1, 1, 0 },
		 { 0, 1, 1, 1, 1, 1, 1, 0 },
		 { 0, 0, 1, 1, 0, 0, 0, 0 },
		 { 0, 0, 0, 1, 0, 0, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 }},
		{{ 0, 0, 0, 0, 0, 0, 0, 0 },	// FubNu
		 { 0, 1, 0, 0, 0, 1, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 },
		 { 0, 1, 0, 0, 0, 1, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 }},
		{{ 0, 1, 1, 0, 1, 1, 0, 0 },	// n[g
		 { 1, 1, 1, 1, 1, 1, 1, 0 },
		 { 1, 1, 1, 1, 1, 1, 1, 0 },
		 { 1, 1, 1, 1, 1, 1, 1, 0 },
		 { 0, 1, 1, 1, 1, 1, 0, 0 },
		 { 0, 0, 1, 1, 1, 0, 0, 0 },
		 { 0, 0, 0, 1, 0, 0, 0, 0 },
		 { 0, 0, 0, 0, 0, 0, 0, 0 }}
	};

	if (argc != 6 && argc != 7) {
		fprintf(stderr, "Usage: convcharaorgbmp infile outfile size patnum offset [-b]\n");
		fprintf(stderr, "size=0:8x8x1 size=1:8x8x3 size=2:16x8x3 size=3:16x16x3\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	size = atoi(argv[3]);
	patnum = atoi(argv[4]);
	offset = atoi(argv[5]);

	bmpflag = 0;
	if (argc == 7) {
		if (strcmp(argv[6],"-b") != 0) {
			fprintf(stderr, "Illigal option\n");
		} else {
			bmpflag = 1;
		}
	}

	width  = 8;
	height = 8;

	switch (size) {
		case 0:
			w_mul = 1;
			h_mul = 1;
			plnum = 1;
			break;
		case 1:
			w_mul = 1;
			h_mul = 1;
			plnum = 3;
			break;
		case 2:
			w_mul = 2;
			h_mul = 1;
			plnum = 3;
			break;
		case 3:
		default:
			w_mul = 2;
			h_mul = 2;
			plnum = 3;
			break;
	}


	for (y = 0;y < MAXHEIGHT;y ++) {
		for (x = 0;x < MAXWIDTH;x ++) {
			pixel_all[x][y] = 0x07;
		}
	}


	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < 8;y ++) {
			for (x = 0;x < 8;x ++) {
				pixel[x][y][z] = 0x08;
			}
		}
	}

	for (col = 0x01;col < 0x08;col *= 2) {

		for (z = 0;z < MAXCHARA;z ++) {
			for (y = 0;y < 8;y ++) {
				if (z < 256) {
					c = fgetc(infp);
					sft = 0x80;
					for (x = 0;x < 8;x ++) {
						if ( (c & sft) != 0) {
							pixel[x][y][z] |= col;
						}
						sft /= 2;
					}
				} else {
					for (x = 0;x < 8;x ++) {
						if (fixpat[z-256][y][x] != 0) {
							pixel[x][y][z] |= col;
						}
					}
				}
			}
		}

	}

	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < 8;y ++) {
			for (x = 0;x < 8;x ++) {
				if (pixel[x][y][z] == 0x0b) {
					pixel[x][y][z] = 0x08;		/*  */
				}
			}
		}
	}

	for (z = 0;z < patnum;z ++) {
		for (yy = 0;yy < h_mul;yy ++) {
			for (xx = 0;xx < w_mul;xx ++) {
				for (y = 0;y < height;y ++) {
					for (x = 0;x < width;x ++) {
						pixel_all[x+xx*width][y+yy*height+z*h_mul*height] =
						pixel[x][y][z*w_mul*h_mul+offset+xx+yy*w_mul];
					}
				}
			}
		}
	}


	if (!bmpflag) {

		if (plnum == 3) {

			for (z = 0;z < patnum;z ++) {
				for (yy = 0;yy < h_mul;yy ++) {
					for (xx = 0;xx < w_mul;xx ++) {
						for (y = 0;y < height;y ++) {
							for (x = 0;x < width;x += 2) {
								a0 = (pixel_all[x+0+xx*width][y+yy*height+z*h_mul*height] & 0x0f);
								a1 = (pixel_all[x+1+xx*width][y+yy*height+z*h_mul*height] & 0x0f) << 4;
								fputc(a0|a1, outfp);
							}
						}
					}
				}
			}

		} else if (plnum == 1) {

			for (z = 0;z < patnum;z ++) {
				for (yy = 0;yy < h_mul;yy ++) {
					for (xx = 0;xx < w_mul;xx ++) {
						for (y = 0;y < height;y ++) {
							a1 = 0;
							for (x = 0;x < width;x ++) {
								a0 = (pixel_all[x+0+xx*width][y+yy*height+z*h_mul*height] & 0x01);
								a1 = a1*2 + a0;
							}
							fputc(a1, outfp);
						}
					}
				}
			}

		}

	} else {

		width_all  = width * w_mul;
		height_all = height* h_mul * patnum;
		outheader(width_all*2, height_all*2, outfp);

		for (y = height_all-1;y >= 0;y --) {
			for (i = 0;i < 2;i ++) {
				for (x = 0;x < width_all;x ++) {
					a0 = (pixel_all[x][y] & 0x0f) << 4;
					a1 = (pixel_all[x][y] & 0x0f);
					fputc(a0|a1, outfp);
				}
			}
		}

	}

	fclose(outfp);
	fclose(infp);

	return(0);
}

void	fput4b(int d,FILE *fp)
{
	int	d0,d1,d2,d3;

	d0 = (d & 0x000000ff);
	d1 = (d & 0x0000ff00) >> 8;
	d2 = (d & 0x00ff0000) >> 16;
	d3 = (d & 0xff000f00) >> 24;

	fputc(d0,fp);
	fputc(d1,fp);
	fputc(d2,fp);
	fputc(d3,fp);

	return;
}

void	outheader(int w,int h,FILE *fp)
{
	int		fsize;

	fputc(0x42,fp);	// wb_[
	fputc(0x4d,fp);

	if ( (w & 0x01) != 0x00) {
		fsize = (w+1)*2*h + 0x76;
	} else {
		fsize = w*2*h + 0x76;
	}

	fput4b(fsize,fp);	// t@CTCY

	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000076,fp);	// ɌŒl
	fput4b(0x00000028,fp);	// 40
	fput4b(w,fp);	// 
	fput4b(h,fp);	// 

	fputc(0x01,fp);	// ɂP
	fputc(0x00,fp);

	fputc(0x04,fp);	// ɂS
	fputc(0x00,fp);

	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000000,fp);	// ɂO
	fput4b(0x00000010,fp);	// pbg
	fput4b(0x00000000,fp);	// ɂO

	// pbg

	fput4b(0x00000000,fp);
	fput4b(0x00ac00ff,fp);
	fput4b(0x00acff00,fp);
	fput4b(0x00ff00ac,fp);
	fput4b(0x0000ffac,fp);
	fput4b(0x0000acff,fp);
	fput4b(0x00acff00,fp);
	fput4b(0x00acacac,fp);
	fput4b(0x00000000,fp);
	fput4b(0x000000ff,fp);
	fput4b(0x00ff0000,fp);
	fput4b(0x00ff00ff,fp);
	fput4b(0x0000ff00,fp);
	fput4b(0x0000ffff,fp);
	fput4b(0x00ffff00,fp);
	fput4b(0x00ffffff,fp);

	return;
}

