/******************************************/
/* generate command file for Binary patch */
/******************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXLINE		255
#define	MAXBUFF		0x10000

int	convhex(char);

int main(int argc, char **argv)
{
	FILE	*infp, *outfp, *cmdfp;
	char	line[MAXLINE];
	int		buff[MAXBUFF];

	int		lineno;
	int		i, c, cnt;
	int		add, stadd, dat_b, dat_a;

	if (argc != 4) {
		fprintf(stderr, "Usage: swapdat infile outfile cmdfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((cmdfp = fopen(argv[3], "r")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

/* R}ht@Ce */
/* LqHEX        */
/* AhX͂S   */
/* f[^͂Q     */
/*                  */
/* X^[gAhX */
/* ϊOf[^     */
/* ϊf[^     */
/* KpAhX     */
/* @F             */
/* KpAhX     */


	cnt = 0;
	while ( (c = fgetc(infp)) != EOF) {
		buff[cnt] = c;
		cnt ++;
	}

	lineno = 1;

	while ( fgets(line, MAXLINE, cmdfp) != NULL) {
		if (lineno == 1) {
			stadd  = (convhex(line[0]) * 0x1000);
			stadd += (convhex(line[1]) * 0x0100);
			stadd += (convhex(line[2]) * 0x0010);
			stadd += (convhex(line[3]) * 0x0001);
		} else if (lineno == 2) {
			dat_b  = (convhex(line[0]) * 0x0010);
			dat_b += (convhex(line[1]) * 0x0001);
		} else if (lineno == 3) {
			dat_a  = (convhex(line[0]) * 0x0010);
			dat_a += (convhex(line[1]) * 0x0001);
		} else {
			add  = (convhex(line[0]) * 0x1000);
			add += (convhex(line[1]) * 0x0100);
			add += (convhex(line[2]) * 0x0010);
			add += (convhex(line[3]) * 0x0001);

			if (buff[add-stadd] == dat_b) {
				buff[add-stadd] = dat_a;
			} else {
				fprintf(stderr, "ADDRESS:%04x DATA:%02x  Illigal\n", add, dat_b);
			}

		}
		lineno ++;
	}

	for (i = 0;i < cnt;i ++) {
		fputc(buff[i], outfp);
	}

	fclose(infp);
	fclose(outfp);
	fclose(cmdfp);


	return(0);
}

int convhex(char ch)
{
	int		rt;
	if ('0' <= ch && ch <= '9') {
		rt = ch - '0';
	} else if ('a' <= ch && ch <= 'f') {
		rt = ch - 'a' + 10;
	} else if ('A' <= ch && ch <= 'F') {
		rt = ch - 'A' + 10;
	} else {
		rt = -1;
	}

	return rt;
}


